/*
 * Tienda online
 * Proyecto Fin de Máster de Ingeniería Informatica UOC
 * Emilio Domínguez Sánchez
 * 
 */
package tiendaonline.model.adjunto;

import java.sql.Blob;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;

import tiendaonline.model.ropa.Ropa;

/**
 *
 * @author emilio
 */
@Entity
public class Adjunto  {
  
  
    private long idAdjunto;
    private String nombreAdjunto;
    private Blob imagen;
    private Ropa ropa;
    

    public Adjunto(){};
    public Adjunto(String nombreAdjunto) {
        this.nombreAdjunto = nombreAdjunto;
    }

    public Adjunto(String nombreAdjunto, Blob imagen, Ropa ropa) {
        this.nombreAdjunto = nombreAdjunto;
        this.imagen = imagen;
        this.ropa = ropa;
    }

    @Column(name = "idAdjunto")
    @SequenceGenerator( // It only takes effect for
    name = "idAdjuntoGenerator", // databases providing identifier
    sequenceName = "AdjuntoSeq")
    // generators.       
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "idAdjuntoGenerator")

    public long getIdAdjunto() {
        return idAdjunto;
    }

    public void setIdAdjunto(long idAdjunto) {
        this.idAdjunto = idAdjunto;
    }

    public String getNombreAdjunto() {
        return nombreAdjunto;
    }

    public void setNombreAdjunto(String nombreAdjunto) {
        this.nombreAdjunto = nombreAdjunto;
    }

 @ManyToOne(optional=false, fetch=FetchType.LAZY)
    @JoinColumn(name="idRopa")
    public Ropa getRopa() {
    return ropa;
  }

  public void setRopa(Ropa ropa) {
    this.ropa = ropa;
  }

  @Lob
  @Column (name="imagen")
    public Blob getImagen() {
        return imagen;
    }

    public void setImagen(Blob imagen) {
        this.imagen = imagen;
    }

    
    
}
