/*
 * Tienda online
 * Proyecto Fin de Máster de Ingeniería Informatica UOC
 * Emilio Domínguez Sánchez
 * 
 */

package tiendaonline.model.comentario;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import es.udc.pojo.modelutil.dao.GenericDaoHibernate;

/**
 *
 * @author emilio
 */
@Repository("ComentarioDao")
public class ComentarioDaoHibernate extends GenericDaoHibernate<Comentario, Long> implements ComentarioDao {

	@Autowired
	private SessionFactory sessionFactory;

	public List<Comentario> listaComentario() {

		Query query = getSession().createQuery("SELECT u FROM Comentario u ");
		List<Comentario> listaComentario = query.list();
		return listaComentario;

	}

	public List<Comentario> listaComentario(long idRopa) {
		Query query = getSession().createQuery("SELECT a FROM Comentario a WHERE a.ropa.idRopa = :idRopa")
				.setParameter("idRopa", idRopa);
		List<Comentario> listaComentario = query.list();
		return listaComentario;

	}

	public void anadirComentario(Comentario comentario) {
		sessionFactory.getCurrentSession().save(comentario);

	}

	public void borrarComentario(Comentario comentario) {
		sessionFactory.getCurrentSession().delete(comentario);
	}
}
