/*
 * Tienda online
 * Proyecto Fin de Máster de Ingeniería Informatica UOC
 * Emilio Domínguez Sánchez
 * 
 */

package tiendaonline.model.recomendacion;

import java.util.List;

import es.udc.pojo.modelutil.dao.GenericDao;
import es.udc.pojo.modelutil.exceptions.InstanceNotFoundException;
import tiendaonline.model.ropa.Ropa;

/**
 *
 * @author emilio
 */
public interface RecomendacionDao extends GenericDao<Recomendacion, Long> {

	/**
	 * Returns an Recomendacion by idRecomendacion ( Recomendacion identifier)
	 *
	 * @param idRecomentadion
	 *            the Recomendacion identifier
	 * @return the Recomendacion
	 */

	public Recomendacion findByIdsRopa(Ropa idRopa1, Ropa idRopa2) throws InstanceNotFoundException;

	public List<Recomendacion> listaTodasRecomendaciones();

	public void insertarRecomendacion(Recomendacion recomendacion);

	public List<Ropa> listadeIds2(Ropa idRopa1);

	public List<Ropa> listadeIds1(Ropa idRopa2);

	public List<Recomendacion> findidRopaRecomendacion(long idRopa1) throws InstanceNotFoundException;

	public void borrarRecomendacion(long idRecomendacion);

}
