/*
 * Tienda online
 * Proyecto Fin de Máster de Ingeniería Informatica UOC
 * Emilio Domínguez Sánchez
 * 
 */
package tiendaonline.web.pages.blog;

import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.ioc.annotations.Inject;

import es.udc.pojo.modelutil.exceptions.InstanceNotFoundException;
import tiendaonline.model.administradorservice.AdministradorService;
import tiendaonline.model.entradablog.EntradaBlog;
import tiendaonline.web.pages.Administracion;
import tiendaonline.web.services.Private;
import tiendaonline.web.util.UserSession;

@Private
public class ModificarEntradaBlog {

	@Property
	private String titulo;
	@Property
	private String resumen;
	@Property
	private String texto;

	@SessionState(create = false)
	EntradaBlog entradaBlog;
	
	@SessionState(create = false)
	private UserSession userSession;

	@Inject
	AdministradorService administradorService;

	void onActivate(long idEntradaBlog) throws InstanceNotFoundException {
		entradaBlog = administradorService.findEntradaBlog(idEntradaBlog);

	}

	void onPrepareForRender() {
		titulo = entradaBlog.getTitulo();
		resumen = entradaBlog.getResumen();
		texto = entradaBlog.getTexto();
	}

	void onValidateFromModificarEntradaForm() throws InstanceNotFoundException {
		administradorService.modificarEntradaBlog(entradaBlog.getIdEntradaBlog(),userSession.getUserProfileId(),titulo, resumen,
				texto);
	}
	Object onSuccess() throws InstanceNotFoundException {
		administradorService.modificarEntradaBlog(entradaBlog.getIdEntradaBlog(),userSession.getUserProfileId(),titulo, resumen,
				texto);
		return Administracion.class;

	}

	public EntradaBlog getEntradaBlog() {
		return entradaBlog;
	}

	public void setEntradaBlog(EntradaBlog entradaBlog) {
		this.entradaBlog = entradaBlog;
	}


}
