/*
 * Tienda online
 * Proyecto Fin de Máster de Ingeniería Informatica UOC
 * Emilio Domínguez Sánchez
 * 
 */
package tiendaonline.web.pages.categoria;

import java.util.List;

import org.apache.tapestry5.SelectModel;
import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.corelib.components.Form;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.SelectModelFactory;

import tiendaonline.model.administradorservice.AdministradorService;
import tiendaonline.model.categoria.Categoria;
import tiendaonline.web.pages.Index;
import tiendaonline.web.services.Private;

/**
 *
 * @author Emilio
 */
@Private
public class CrearCategoria {

	@Property
	private String nombreCategoria;

	@Property
	private int idCategoriaPadre;

	@Component
	private Form crearCategoriaForm;

	@Inject
	private AdministradorService administradorService;

	void onValidateFromcrearCategoriaForm() {

		if (!crearCategoriaForm.isValid()) {
			return;
		}

		administradorService.crearCategoria(nombreCategoria, idCategoriaPadre);

	}

	Object onSuccess() {

		return Index.class;

	}

	@Property
	private SelectModel categoriaSelectModel;

	@Inject
	SelectModelFactory selectModelFactory;

	void setupRender() {
		// invoke my service to find all descuentos, e.g. in the database
		List<Categoria> categorias = administradorService.listaCategoria();

		// create a SelectModel from my list of descuentos
		categoriaSelectModel = selectModelFactory.create(categorias, "nombreCategoria");
	}

}