/*
 * Tienda online
 * Proyecto Fin de Máster de Ingeniería Informatica UOC
 * Emilio Domínguez Sánchez
 * 
 */
package tiendaonline.web.pages.categoria;

import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;

import es.udc.pojo.modelutil.exceptions.InstanceNotFoundException;
import tiendaonline.model.administradorservice.AdministradorService;
import tiendaonline.model.categoria.Categoria;
import tiendaonline.web.pages.Index;
import tiendaonline.web.services.Private;

/**
 *
 * @author Emilio
 */
@Private
public class VerCategoria {

	@Property
	private long idCategoria;

	@Property
	private long idCategoria2;

	@Property
	private String nombreCategoria;
	@Property
	private long idCategoriaPadre;

	Categoria categoria;

	@Inject
	AdministradorService administradorService;

	void onActivate(long idCategoria) throws InstanceNotFoundException {
		categoria = administradorService.findCategoria(idCategoria);

	}

	void onPrepareForRender() {
		idCategoria2 = categoria.getIdCategoria();
		nombreCategoria = categoria.getNombreCategoria();
		idCategoriaPadre = categoria.getIdCategoriaPadre();
	}

	Object onSuccess() throws InstanceNotFoundException {
		administradorService.actualizarCategoria(idCategoria2, nombreCategoria, idCategoriaPadre);
		return Index.class;

	}
}
